# abstract.rb: written by Takashi SUGA 2002-03-20 v0.6(suchowan@box.email.ne.jp)
#
#    A   BBBB   SSSS TTTTT RRRR    A    CCC  TTTTT
#   A A  B   B S       T   R   R  A A  C   C   T  
#  A   A BBBB   SSS    T   RRRR  A   A C       T  
#  AAAAA B   B     S   T   R  R  AAAAA C   C   T  
#  A   A BBBB  SSSS    T   R   R A   A  CCC    T  
#
=begin
#=Yet Another Date Class
\==when.exe  Ruby ̂߂̌
\===͂߂
\<a href="http://www.asahi-net.or.jp/~dd6t-sg/whenhome.html">when.exe</a>
\<a href="http://www.ruby-lang.org">Ruby</a> sĂ܂B
\̃Cuł
\<a href="http://www.ruby-lang.org/en/raa-list.rhtml?name=date2">date2</a>,
\<a href="http://www.ruby-lang.org/en/raa-list.rhtml?name=newdate">newdate</a>
\Qlɂ
\<a href="http://www.asahi-net.or.jp/~dd6t-sg/date/v03.zip">i(v0.3)</a>
\Ă݂܂(1/86,400,000,000 PʂƂĐl\ fraction.rb ƁA
\1sȊÕRgׂĎ苎XNvg exec.rb ͓Ă܂)B
\܂S͂łĂ܂񂪁AAh@CX΍Kł(o[W̎dlĂ
\<a href="http://www.asahi-net.or.jp/~dd6t-sg/DateClass.html"></a>)B


=end

=begin ######################################################################
#===p  ڎ                                                          #
|===Inheritance Tree:                                                       #
#                                                                           #
\ p؂LɎ܂BꂼNbNƏڍאo܂B        #
#                                                                           #
# Object*--+-Date*-Date::Extended+ +-Eras+                                  #
#          |                       |                                        #
#          |                       |                                        #
#          +-Range*----Period      +-Civil+                                 #
#          |                       |                                        #
#          |                       |                                        #
#          +-Outfit+-+-Calendar+---+-DMD+     +-IndiaB+---Surya             #
#                    |             |          |                             #
#                    |             |          +-Tibet+                      #
#                    |             |          |                             #
#                    +-Residue+    +-EMD+-----+-ChinaB+-+-ChinaJ+--ChinaS+  #
#                    |             |          :         |                   #
#                    |             |          +-FMD0+   +-ChinaT            #
#                    |             |          |                             #
#                    +-Ephemeris+  +-FMD+-----+-FMD1+---+-Java              #
#                    |                        |         |                   #
#                    |                        +-FMD2+   +-Maya              #
#                    +-Location               |                             #
#                    |                        +-Week+-----Easter+           #
#                    |                        |                             #
#                    +-Timezone+-----DST+     +-ThaiC+----ThaiB+            #
#                                             |                             #
#                                             +-Jewish+                     #
=end ########################################################################

=begin
\===t̊{\(`)
\
\ CCYY-MM-DD[T[hh:mm:ss.s[Z|+ZZ[:]zz]]]
\     a  b   c   d          e
\
\ yvz
\
\  (1) ʏpĂ鐼̏ꍇAISO8601 ̊g\ƓƂȂB
\  (2) 1N11Ɏn܂Ȃ@(:vNx)\ł悤ɂB
\  (3) 1ߑO0Ɏn܂Ȃ@(:CX)\ł悤ɂB
\  (4) ̑Az̓t\ł悤ɂB
\  (5) Ch̑Az̓t\ł悤ɂB
\  (6) CCYY  '   0' ` '9999' ͈̔͂ɓꍇA̗@/ɑ΂
\      ɂ鏸\[gŁAt\[głB 
\
\ y؂蕶z
\
\  \̒ʂƂB̋؂肪ߑO0̏ꍇ'-'̂'T'pB
\     
\  +----------+-------+-------------------------------------+---------+------+
\  |؂蕶|   a   |                b                    |    c    |  e   |
\  |          +--+----+--+------+------+------+------+------+--+------+      |
\  |    (code)| Y|    | M|  S1  |  S2  |  S3  |  S4  |̑| D|      |      |
\  +----------+--+----+--+------+------+------+------+------+--+------+------+
\  | !  (0x21)|  |    |-5|      |      |  |      |      |  |      |      |
\  | %  (0x25)|  |    |-4|      |[|      |      |d|  |      |      |
\  | &  (0x26)|  |    |-3|[|[|[|      |      |  |      |      |
\  | *  (0x2A)|-1|ON|-2|[|      |[|      |      |-1| O |      |
\  | +  (0x2B)|  |    |-1|      |  |      |      |      |  |      |o|
\  | -  (0x2D)| 0|N| 0|  |  |  |  |ʏ팎| 0|  |o|
\  | <  (0x3C)|  |    | 1|  |      |      |  |      |  |      |      |
\  | =  (0x3D)| 1|N| 2|      |      |      |[| [ | 1|  |      |
\  | >  (0x3E)|  |    | 3|      |      |      |[|      | 2|X|      |
\  +---+------+--+----+--+------+------+------+------+------+--+------+------+
=end

=begin
\===t̊{\(`)  ([]͔z, {}̓nbV)
\
\ yNz
\    ʌ`  =   [N, ԍ, [N̏ʊKw, .. , [N, ItZbg]]]
\      N          :   Eras+NX̏ꍇɔN肷邽߂ɔN܂B
\                        Ήl`ĂƂ'.'ŋ؂
\                        ĂɂȂ܂B
\      ԍ      :   ̃L[ɈvNꍇAԍ
\                        N肵܂(ႦΓVۂƂŃA{A
\                        kĂ3ɂ܂)B
\      N̏ʊKw  :   N̏ʊKwꍇɂ܂B}̃JgDE
\                        oNgDA邢̓MṼIsA[hԍȂǁB
\      N            :   ɂ܂BPȂ鐮łAʂ̗ł́Aꂾ
\                        ŔNwł܂B
\      ItZbg    :   ^pƗ@ŔN̋؂肪قȂꍇɂ܂Bꂪ
\                        ƂIȗ͖NłB@̓OS
\                        IłN͒aN̋؂ł(ItZbgl
\                        ͏\ Y ̒ʂł)B ['A', [42, 1]]  'A' 
\                        ߂Ă邪aOŖ42΂ł邱Ƃ
\                        Ba߂ ['A', [43, 0]] ɂȂ܂B
\
\ yz
\    ʌ`  =   [ԍ, ڍהԍ]  ([]͔z, ڍהԍȂȂ炽̐)
\      ԍ        :   [ƔE𖳎̒ʂԍłB
\                        ʂ̗ł́AꂾŌwł܂B
\      ڍהԍ      :   Ή[ƔE܂(l͏\ M 
\                        ʂłB
\
\ yz
\    ʌ`  =   [ԍ, ItZbg]  ([]͔z, ItZbgȂȂ炽̐)
\      ԍ        :   ̋؂A]E𖳎̒ʂԍłB
\                        ʂ̗ł́Aꂾœwł܂B
\      ItZbg    :   ^pƗ@œ̋؂肪قȂꍇAї]̂
\                        @̏ꍇɂ܂BCX[ChT^I
\                        ł(l͏\ D ̒ʂł)B
\
\ yzyzybzyb̏z
\    ʌ`  =   ʂԍ
\      ʂԍ      :   b̒ʂԍӖ鐮(Integer*)ƕb̏
\                        Ӗ镪(Rational*)łB
\                        ĎԂ~Ԃւ̕ύX[b̑}ɁA
\                        [d鎞܂͕b, 1]Ƃzɂ邩܂
\                        񂪁Ǎۑł܂Ă܂B
=end

=begin
\===݂̃Xe[^X
\
\̍
\
\  f[^̈ڍs
\    MS-DOSł(oO͂Ă)f[^ڍsB
\      AxA}260/365AW etc
\
\  G[𐮗B
\
\  NƓ̎wɏ]ނ悤ɂB
\
\  Marshal ɑΉB
\
\_
\
\  Eras
\    ǂݍݎɖANJn̓tEXʓ̂͏璷B
\    Marshal ȂǂgāAׂB
\
\  Marshal
\    Calendar  Proc IuWFNgێĂ(_m_in_y, d_in_m̌vẐ)
\    ̂ŁAMarshal łȂBKvB
\
\  IndiaB
\    ̏ǒvZ܂gݍ܂ĂȂ߁AbIBV̈ʒuvZ
\    W[MS-DOSł̈ڍsKv
\
\  ThaiC
\    wVwjW(3W)x̃f[^ł܂vZȂ̂ŁAmF
\    KvB
\
\  Tibet
\    wI^Hx̃ASYA܂ date.rb ̃A[LeN
\    `ɕϊĂȂ߁A]̕\L̗ƐĂȂBvB
\
\  DST
\    ĎԂ~Ԃւ̐ؑ֎́A1Ԃ̏dĂȂB[Ȃ
\    ܂߂āA΍lKvB
=end
