# easter.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#  EEEEE   A    SSSS TTTTT EEEEE RRRR 
#  E      A A  S       T   E     R   R
#  EEEE  A   A  SSS    T   EEEE  RRRR 
#  E     AAAAA     S   T   E     R  R 
#  EEEEE A   A SSSS    T   EEEEE R   R
#
=begin ##########################################################
#=Easter                                                        #
\===ۂƂT                                      #
$===Calendar weekar for easter                                  #
\ LXĝuՂƂړՓv܂  #
\ tɌŒ肳܂BLXg֌W̗̌vZɗp܂B    #
\==X[p[NX:                                              #
$==Super Class:                                                 #
#*Week+                                                         #
=end ############################################################

class Easter < Week

=begin #########################################################
\==NX \bh:                                            #
$==Class Method:                                               #
=end ###########################################################
  class << self

=begin ***********
#--- Easter.instance(key)
\  ɑΉCX^X𐶐܂B
\
\    key  CX^Xw肷镶
=end =============
    def instance(key)
      case key
      when /^Easter$/i
        Easter.new(
          'Title'         => 'Easter',
          'BaseCalendar'  => Calendar.get('Gregorian'),
          'NewYearOffset' => 9,
          'DayOfWeek'     => 0
        )
      else; nil
      end
    end
  end # of class method

=begin ***********
#--- Easter.new(*quality or [offset=9 [, dayofweek=0])
\  Week+IuWFNg𐶐ĕԂ܂B
\
\    quality  @̐`nbV
\  or
\    offset     ՂoffsetTԑON̍ŏ̏Tɂ܂B
\    dayofweek  T̎n߂̎j(0:j,..,6:yj)
=end =============
# def initialize(*quality)
#   super
# end

=begin #########################################################
\==uCx[g CX^X \bh:                         #
$==Private Instance Method:                                    #
=end ###########################################################
  private

=begin ***********
#--- Week#_new_year(year)
\  year Ŏw肵N̎n߂̒nߒʓԂ܂B
\
\    year  N 
=end =============
  def _new_year(year)
      @BaseCalendar.easter(year) - 
      @NewYearOffset   * 7       +
    ( @DayOfWeek + 1 ) % 7
  end

=begin ***********
#--- Week#_qualify
\  Easter+IuWFNg̐`ݒ肵܂B
\
\    @BaseCalendar  = x[XƂėp@(Calendar+)IuWFNg
\    @NewYearOffset = Ղ@NewYearOffsetTԑON̍ŏ̏Tɂ܂B
\    @DayOfWeek     = T̎n߂̎j(0:j,..,6:yj)
=end =============
# def _qualify
#   super
# end
################################################################
  func :_new_year
end
