# fmd2.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#  FFFFF M     M DDDD   222 
#  F     MM   MM D   D 2   2
#  FFFF  M M M M D   D    2 
#  F     M  M  M D   D   2  
#  F     M     M DDDD  22222
#
=begin ########################################################
#=FMD2                                                        #
\===N𑾗zoŌ肷                                #
\ ftHg̓C̃wWzłB                      #
\==X[p[NX:                                            #
$==Super Class:                                               #
#*FMD+                                                        #
=end ##########################################################

class FMD2 < FMD

=begin #########################################################
\==NX \bh:                                            #
$==Class Method:                                               #
=end ###########################################################
  class << self

=begin ***********
#--- FMD2.instance(key)
\  ɑΉCX^X𐶐܂B
\
\    key  CX^Xw肷镶
=end =============
    def instance(key)
      case key
      when /^Iran$/i
        FMD2.new(
          'Title'     =>  'Iran',
          'DayBorder' =>   18,
          'MonthNames'=>  %w( 
            Ferverdin  Ardebehesht  Khordad  Tir
            Mordad     Shahrivar    Mehr     Aban
            Adser      Dei          Bahmen   Asfend
          ),

          'RuleTable' =>  {
            365 => {'Length'=>[31,31,31,31,31,31,30,30,30,30,30,29]},
            366 => {'Length'=>[31,31,31,31,31,31,30,30,30,30,30,30]}
          },

          # Default Parameters
          'YearEpoch'     =>    621,
          'CycleOffset'   =>      0,
          'Months_in_Year'=>     12,
          'MeanMonth'     =>   (365 + Rational(31,128)) / 12,
          'DayOffset'     =>      0.5,
          'Timezone'      =>      3.5
        )
      when /^French$/i
        FMD2.new(
          'Title'      => 'French',

          'MonthNames' => %w( 
             Vendemiaire Brumaire Frimaire  Nivose
             Pluviose    Ventose  Germinal  Floreal
             Prairial    Messidor Thermidor Fructidor
             Sansculottide
           ),

          'RuleTable' =>  {
            365 => {'Length'=>[30,30,30,30,30,30,30,30,30,30,30,30, 5]},
            366 => {'Length'=>[30,30,30,30,30,30,30,30,30,30,30,30, 6]}
          },

          # Default Parameters
          'YearEpoch'     =>  1792,
          'CycleOffset'   =>     0.5,
          'Months_in_Year'=>    13,
          'MeanMonth'     =>  (365 + Rational(31,128)) / 13,
          'DayOffset'     =>     0,
          'Timezone'      =>     2.45 / 15
        )
      else; nil
      end
    end
  end # of class method

=begin ***********
#--- FMD2.new([quality={})
\  FMD2+IuWFNg𐶐ĕԂ܂B
\
\    quality  @̐`nbV
=end =============
  def initialize(quality={})
    _copy_quality(quality)
    _qualify
  end

=begin #########################################################
\==uCx[g CX^X \bh:                         #
$==Private Instance Method:                                    #
=end ###########################################################
  private

=begin ***********
#--- FMD2#_new_year(y)
\  y Ŏw肵N̎n߂̒nߒʓԂ܂B
\
\    y  N 
=end =============
  def _new_year(y)
    t = @Ephemeris.cn_to_time( y.to_f + @YearEpoch +
                                        @CycleOffset )
    return (t + 0.5 + @DayOffset + @Timezone).floor
  end

=begin ***********
#--- FMD2#_qualify
\  FMD2+IuWFNg̐`ݒ肵܂B
\
=end =============
  def _qualify

    @Timezone  /= 24.0
    @Ephemeris  = '1S'
    unless (@Ephemeris = Ephemeris.get(@Ephemeris))
      @Ephemeris = Ephemeris.get('1S')
    end

    super
  end
################################################################
  func :_new_year
end
