# func.rb: Written by Tadayoshi Funaba 2000
#          Revised by Takashi   Suga   2002

class Module

  def func(*ids)
    for id in ids
      module_eval <<-"end;"
	alias_method :__#{id.to_i}__, :#{id.id2name}
	def #{id.id2name}(*args, &block)
	  @__#{id.to_i}__ ||= {}
	  return (@__#{id.to_i}__[args])[0] if @__#{id.to_i}__.key?(args)
	  (@__#{id.to_i}__[args] = [__#{id.to_i}__(*args, &block)])[0]
	end
      end;
    end
  end

  private :func

  def func_class_method(*ids)
    for id in ids
      module_eval <<-"end;"
	class << self
	  func :#{id.id2name}
	end
      end;
    end
  end

  private :func_class_method

end
