# outfit.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#   OOO  U   U TTTTT FFFFF I TTTTT
#  O   O U   U   T   F     I   T  
#  O   O U   U   T   FFFF  I   T  
#  O   O U   U   T   F     I   T  
#   OOO   UUU    T   F     I   T  
#
=begin #########################################################
#=Outfit                                                       #
\===戵NX                                           #
#                                                              #
\==X[p[NX:                                             #
$==Super Class:                                                #
#*Object*                                                      #
=end ###########################################################

class Outfit

=begin #########################################################
\==NX \bh:                                            #
$==Class Method:                                               #
=end ###########################################################

=begin ***********
#--- Outfit.clear
\  戵f[^x[X܂B
\
\*NXϐ
\  @@outfit ̗vf
\    Key0 => 戵(Outfit+)IuWFNgpL[f[^x[Xl
\    Keys => 戵(Outfit+)IuWFNgpL[f[^x[X
\    Objs => ςݗ戵(Outfit+)IuWFNgf[^x[Xz
\    Hash => ςݗ戵(Outfit+)IuWFNgf[^x[XnbV
=end =============
    def self.clear
      @@outfit['Keys'] = @@outfit['Key0'].dup
      @@outfit['Objs'] = []
      @@outfit['Hash'] = {}
    end
  
=begin ***********
#--- Outfit.register(key, &proc)
\  L[Ƃ̃L[ɑΉ葱o^܂B
\
\    key  戵(Outfit+)IuWFNgL[
\    proc 葱(Proc*)IuWFNg
=end =============
    def self.register(key, &proc)
      if (k = @@outfit['Hash'][key])
        @@outfit['Keys'][k] = [key, proc]
      else
        @@outfit['Hash'][key] = @@outfit['Keys'].length
        @@outfit['Keys'].push([key, proc])
      end
    end

=begin #########################################################
\==nubN CX^X \bh:                           #
$==Public Instance Method:                                     #
=end ###########################################################
  public

=begin ***********
#--- Outfit#name
\  ̂Ԃ܂B
=end =============
  def name() _title[0] end

=begin ***********
#--- Outfit#_title
\  Outfit+IuWFNg title Ԃ܂B
\
=end =============
  def _title
    return [] unless @Title
    return @Title
  end

=begin ***********
#--- Outfit#to_hash
\  ׂĂ̐`i[nbVԂ܂B
=end =============
  def to_hash
    hash = {}
    instance_variables.each do |var| 
      hash[var[1..-1]] = eval(var) if var =~ /^@[A-Z]/
    end
    return hash
  end

=begin ***********
#--- Outfit#[](name)
\  `Ԃ܂B
\
\  name  `
=end =============
  def [](name)
    return nil unless String === name && name =~ /^[A-Z]/
    eval("@#{name}")
  end

=begin #########################################################
\==veNebh CX^X \bh:                       #
$==Prptected Instance Method:                                  #
=end ###########################################################
  protected

=begin ***********
#--- Outfit#[]=(name, value)
\  `XV܂B
\
\  name  `
\  value Vl
=end =============
  def []=(name, value)
    return nil unless String === name && name =~ /^[A-Z]/
    eval("@#{name} = value")
  end

=begin #########################################################
\==uCx[g CX^X \bh:                         #
$==Private Instance Method:                                    #
=end ###########################################################
  private

=begin ***********
#--- Outfit#_copy_quality
\  Ƃė^ꂽ`nbVCX^Xϐ܂B
\
=end =============
  def _copy_quality(quality)
    quality.each_key do |key|
      if key =~ /^[A-Z]/
        eval("@#{key} = quality['#{key}']")
      else
        raise ArgumentError, "Can't overwrite instance variable @#{key}"
      end
    end
  end
end
