# week.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#  W   W EEEEE EEEEE K   K
#  W   W E     E     K  K 
#  W W W EEEE  EEEE  KKK  
#  W W W E     E     K  K 
#   W W  EEEEE EEEEE K   K
#
=begin ##########################################################
#=Week                                                          #
\===T                                                        #
$===Calendar weekar                                             #
#                                                               #
\==X[p[NX:                                              #
$==Super Class:                                                 #
#*FMD+                                                          #
=end ############################################################

class Week < FMD

=begin #########################################################
\==NX \bh:                                            #
$==Class Method:                                               #
=end ###########################################################
  class << self

=begin ***********
#--- Week.instance(key)
\  ɑΉCX^X𐶐܂B
\
\    key  CX^Xw肷镶
=end =============
    def instance(key)
      case key
      when /^Week$/i
        Week.new(
          'Title'         => 'Week',
          'BaseCalendar'  => Calendar.get('Gregorian'),
          'NewYearOffset' => 4,
          'DayOfWeek'     => 1
        )
      else; nil
      end
    end
  end # of class method

=begin ***********
#--- Week.new(*quality or [offset=4 [, dayofweek=1]])
\  Week+IuWFNg𐶐ĕԂ܂B
\
\    quality  @̐`nbV
\  or
\    offset     1offsetŒ
\    dayofweek  T̎n߂̎j(0:j,..,6:yj)
=end =============
  def initialize(*quality)
    if Array === quality
      if Hash === quality[0]
        quality = quality[0]
      else
        if (cal = Calendar.get(quality[0])) then quality.shift
        else cal = Civil.new(true)
        end
        quality = {'BaseCalendar' => cal,
                   'NewYearOffset'=> quality[0],
                   'DayOfWeek'    => quality[1]
                  }
      end
    end
    _copy_quality(quality)
    _qualify
  end

=begin #########################################################
\==uCx[g CX^X \bh:                         #
$==Private Instance Method:                                    #
=end ###########################################################
  private

=begin ***********
#--- Week#_new_year(year)
\  year Ŏw肵N̎n߂̒nߒʓԂ܂B
\
\    year  N 
=end =============
  def _new_year(year)
    d = @BaseCalendar.new_year(year) + @NewYearOffset - 1
    m,  c = d.moddiv(7)
    n = c * 7 + @DayOfWeek
    return (m >= @DayOfWeek) ? n : n - 7
  end

=begin ***********
#--- Week#_qualify
\  Week+IuWFNg̐`ݒ肵܂B
\
\    @BaseCalendar  = x[XƂėp@(Calendar+)IuWFNg
\    @NewYearOffset = 1@NewYearOffsetŒ
\    @DayOfWeek     = T̎n߂̎j(0:j,..,6:yj)
=end =============
  def _qualify

    @DayOfWeek     = (@DayOfWeek + 6) % 7

    @Format        ||= [["%4d-",  "%4d%c",  "-=*"      ], 
                        ["W%02d-","W%02d%c","-<=>!%&*+"],
                        ["%01dT", "%12d%c", "-=*"      ], 
                        ["%02d:", "%02d%c", "-=*"      ],
                        ["%02d:", "%02d%c", "-=*"      ],
                        ["%02d",  "%02d%c", "-=*"      ],
                        [".%02d", ".%02d",  "-=*"      ]]
    unless @IDs
      @IDs       = []
      63.times {|i| @IDs << i+1}
    end

    unless @RuleTable
      @RuleTable = {}
      (42..63).each {|i| @RuleTable[7 * i] = 
        {'Length'=>[7], 'IDs'=>@IDs[0..(i-1)]}
      }
    end

    super
  end
################################################################
  func :_new_year
end
